// Copyright 2016 - Pierre Vuillemin
// License : GNU GPL

function [x,y] = sopi_plot1DProblem(problem, var)
   if problem.nvar ~= 1 then
      error('Can only plot 1D problems')
   end
   xopt = var.opt
   // Domain
   c     = 3
   xLim  = [xopt - c; xopt + c]
   x     = linspace(xLim(1),xLim(2),20)'
   // Objective function
   objective   = sopi_toScilabFunction(problem.objective)
   for i = 1:length(x)
      y(i,1) = objective(x(i))
   end
   yopt     = objective(xopt)
   [x,idx]  = gsort([x;xopt],'g','i')
   y        = [y;yopt]
   y        = y(idx)
   yLim     = [min(y);max(y)]
   // Bound constraints
   sopi_plotLB(problem.lb,1,xLim, yLim)
   sopi_plotUB(problem.ub,1,xLim, yLim)
   // Objective plot
   plot(x,y,'k')
   // Solution
   plot(xopt, yopt, 'r.')
   xstring(xopt+0.1,yopt+0.1, 'xopt')
   name1 = []
   name2 = []
   if ~isempty(var.name)
      name1 = var.name
   else
      name1 = 'x'
   end
   if ~isempty(problem.objective.name)
      name2 = problem.objective.name
   else
      name2 = 'objective'
   end
   xlabel(name1)
   ylabel(name2)
   set(gca(),'data_bounds',[xLim(:),yLim(:)])
endfunction
