// Author : Pierre Vuillemin (2017)
// License : GNU GPL

function R = sopi_load_rules(operator)
   // Loads the rules specific to some operator.
   select operator
   case 'times'
      sopi_loadPropConstants()
      r1   = sopi_newRule('comp',list(CONVEX),list(CONSTANT,POSITIVE), CONVEX)
      r2   = sopi_newRule('comp',list(CONVEX),list(CONSTANT,NEGATIVE), CONCAVE)
      r3   = sopi_newRule('comp',list(CONCAVE),list(CONSTANT,POSITIVE), CONCAVE)
      r4   = sopi_newRule('comp',list(CONCAVE),list(CONSTANT,NEGATIVE), CONVEX)
      function p = newOrder(p,args)
         p1             = args(1)
         p2             = args(2)
         p.data.dorder  = p1.data.dorder + p2.data.dorder
         p.data.norder  = p1.data.norder + p2.data.norder
         if p.data.dorder == 0 & p.data.norder <= 1
            sopi_loadPropConstants()
            p = p + CONVEX + CONCAVE
         end
      endfunction
      r5    = sopi_newRule('all',list(RAT,POLY),RAT, newOrder)
      r6    = sopi_newRule('all',SMOOTH, SMOOTH)
      R     = list(r1,r2,r3,r4,r5,r6)
   case 'sum'
      sopi_loadPropConstants()
      r1 = sopi_newRule('all', CONVEX, CONVEX)
      r2 = sopi_newRule('all', CONCAVE, CONCAVE)
      function p = newOrder(p,args)
         p1             = args(1)
         p2             = args(2)
         p.data.dorder  = max(p1.data.dorder,p2.data.dorder)
         p.data.norder  = max(p1.data.norder + p2.data.dorder, p1.data.dorder + p2.data.norder)
      endfunction
      r3 = sopi_newRule('all', list(RAT,POLY), RAT, newOrder)
      r4 = sopi_newRule('all', SMOOTH, SMOOTH)
      R  = list(r1,r2,r3,r4)
   end
endfunction
