// Author : Pierre Vuillemin (2016)
// License : GNU GPL

function [xopt, fopt, info] = sopi_optim(problem, x0, options, optFields)
   sopi_tryToExtract(options, optFields)
   [fopt,xopt,gopt, work, iters, evals, err]  = optim(list(NDcost,problem.fun.call,problem.fun.data),'b', problem.lb, problem.ub, x0)
   //
   info              = struct()
   info.solverInfo   = struct('gopt',gopt,'work',work,'iters',iters,'evals',evals, 'err',err)
   // TODO: Find a way to extract the value of tolerances
   select err
   case 1
      vflag = 'Norm of the projected gradient lower than tolerance'
   case 2
      vflag = 'Function decrease below tolerance'
   case 3
      vflag = 'Step size below tolerance'
   case 4
      vflag = 'Maximum number of evaluation reached'
   case 5
      vflag = 'Maximum number of iterations reached'
   case 6
      vflag = 'Gradient norm below tolerance'
   case 7
      vflag = 'Stop during calculation of descent direction'
   case 8
      vflag = 'Stop during calculation of estimated gradient'
   case 9
      vflag = 'Local optimum found'
   case 10
      vflag = 'Local optimum found (line search stopped)'
   case 12
      vflag = 'On the bound'
   end
   info.vflag   = vflag
   info.success = or(err == [9,10])
endfunction
