// Author : Pierre Vuillemin (2016)
// License : GNU GPL

function problem = sopi_addConstraints(problem, cList)
   problem.cList = cList;
   for c = cList
      if and(c.isLinear) then
         problem              = sopi_addLinearConstraint(problem, c)
         if and(c.isBound) then
            problem.cType($+1) = 0
         else
            problem.cType($+1) = 1
         end
      else
         if c.type == 'ineq'
            problem.c($+1) = c
         else
            problem.ceq($+1) = c
         end
         problem.cType($+1) = 42
//         error('Only linear constraints are handled in this version')
      end
   end
endfunction

function problem = sopi_addLinearConstraint(problem, c)
   var      = c.lhs
   [A, b]   = sopi_extractAffineForm(var, problem)
   isBound  = c.type =='ineq' &  and(sum(A ~= 0,2) == 1)
   // TODO : check if a bound is set twice
   if isBound then
      for i = 1:size(A,1)
         nonNull  = find(A(i,:) ~= 0)
         ai       = A(i,nonNull)
         if ai > 0 then
            ub          = problem.ub
            ub(nonNull) = -b(i) / ai
            problem.ub  = ub
         else
            lb          = problem.lb
            lb(nonNull) = -b(i) / ai
            problem.lb  = lb
         end
      end
   else
      B  = -b
      if c.type == 'ineq'
         problem.A = [problem.A;A]
         problem.b = [problem.b;B]
      else
         problem.Aeq = [problem.Aeq;A]
         problem.beq = [problem.beq;B]
      end
   end
endfunction
