// Copyright 2015 - Pierre Vuillemin
// License : GNU GPL

// sopiVar * sopiVar ...........................................................
function newVar = %sopiVar_m_sopiVar(var1, var2)
   newSize           = sopi_checkSizesCoherence(var1, var2, 'times')
   newVar            = sopi_newVar('size'       ,  newSize,...
                                   'operator'   ,  'times',...
                                   'args'       ,  list(var1,var2))
   // Properties of the new variable
   P           = sopi_newMatProp(newSize)
   multRules   = sopi_load_rules('times')
   addRules    = sopi_load_rules('sum')
   P1          = var1.prop
   P2          = var2.prop
   m           = size(var1,1)
   o           = size(var1,2)
   n           = size(var2,2)
   for i = 1:m
      for j = 1:n
         for k = 1:o
            newP = sopi_applyRules(multRules,[], list(P1(i)(k),P2(k)(j)))
            if k~=1
               P(i)(j) = sopi_applyRules(addRules, P(i)(j), list(P(i)(j), newP))
            else
               P(i)(j) = newP
            end
         end
      end
   end
   newVar.prop = P
endfunction
