// Author : Pierre Vuillemin (2016)
// License : GNU GPL

// power .......................................................................
function newVar = %sopiVar_p_s(var, pow)
   sopi_print(5,'Power of a sopiVar.\n')
   OP = 'pow'
   if ~var.isSquare then
      error('Power only for square variables');
   end
   if pow == 1 then
      newVar      = var;
   else
      newVar         = sopi_newVar('size'    , size(var),...
                                   'operator', OP)
      // Simplification of arguments
      if var.operator ~= OP
         newVar.args = list(var, sopi_constant(pow))
      else
         newVar.args = list(var.args(1), sopi_constant(pow * var.args(2).args(1)))
      end
      //
      P           = sopi_newMatProp(size(newVar))
      powerRules  = sopi_loadPowerRules(pow)
      newVar.prop = sopi_applyRulesEW(powerRules, P, var.prop)
   end
endfunction

function R = sopi_loadPowerRules(pow)
   sopi_loadPropConstants()
   deff('p = newOrder(p,args)',['p1=args(1)';'p.data.norder = p1.data.norder *'+string(pow);'p.data.dorder = p1.data.dorder *'+string(pow)])
   r1 = sopi_newRule('all', list(RAT,POLY), RAT,newOrder)
   r2 = sopi_newRule('all', SMOOTH, SMOOTH)
   R  = list(r1,r2)
   if modulo(pow,2)==0 then
      r3       = sopi_newRule('all',LINEAR,CONVEX)
      r4       = sopi_newRule('incond',POSITIVE)
      R($+1)   = r3
      R($+1)   = r4
   end
endfunction
