// Author : Pierre Vuillemin (2016)
// License : GNU GPL

function newVar = %sopiVar_sum(var, opt)
   // Overloads the sum function for sopiVar
   //
   // Description
   //    The sum is performed by multiplying the variable with a vector full of
   //    ones on the adequate side.
   //
   if argn(2) < 2 then
      opt = 12;
   end
   if and( opt ~= [1,2,12]) then
      error('wrong dimension for sum direction')
   end
   [m,n] = size(var);
   if opt == 1 then
      // sum along the row dimension
      if m == 1 then
         // only one row, return the var
         newVar = var;
      else
         newVar = ones(1,m) * var;
      end
   elseif opt == 2 then
      // sum along the column dimension
      if n == 1 then
         // only one column, return the var
         newVar = var;
      else
         newVar = var * ones(n,1);
      end
   elseif opt == 12 then
      // sum along both dimensions
      newVar   = sum(sum(var,2),1);
   end
endfunction
