// Author : Pierre Vuillemin (2016)
// License : GNU GPL

function constant = sopi_constant(b)
   // Creates a constant sopiVar.
   //
   // Calling sequence
   //    cons = sopi_constant(b)
   //
   // Parameters
   //    b     : the value of the constant (array)
   //    cons  : the variable representing the constraint (sopiVar)
   //
   constant             = sopi_newVar('size'       , size(b), ..
                                       'operator'  , 'constant',...
                                       'args'      , list(b));
   sopi_loadPropConstants()
   belongsTo   = [CONVEX;CONCAVE;RAT;SMOOTH]
   data        = struct('norder',0,'dorder',0)
   prop        = sopi_newMatProp(size(constant), 'sets', belongsTo, 'data', data)
   si          = sign(b)
   for i = 1:size(b,1)
      for j = 1:size(b,2)
         if si(i,j)>=0
            prop(i)(j) = prop(i)(j) + POSITIVE
         else
            prop(i)(j) = prop(i)(j) + NEGATIVE
         end
      end
   end
   constant.prop = prop
endfunction
