// Author : Pierre Vuillemin (2016)
// License : GNU GPL

function sopi_checkUnavailableOpt(options, possibleOptions, solverName)
   // Checks whether the options are available for a solver.
   //
   // Calling Sequence
   //    sopi_checkUnavailableOpt(options, possibleOptions, solverName)
   //
   // Parameters
   //    options           : user provided options (structure)
   //    possibleOptions   : list of options names (array of string)
   //    solverName        : name of the solver (string)
   //
   // Description
   //    Compares the fields of the user-provided options with the list of
   //    available options for the solver. If the option is not available, then
   //    a warning indicating the name of the unavailable option is printed.
   fields = fieldnames(options)
   for f = fields
      if ~or(f == possibleOptions)
         sopi_print(-1,'''%s'' is not an available option for solver ''%s''. Discarding.',f, solverName)
      end
   end
endfunction
