// Author : Pierre Vuillemin (2016)
// License : GNU GPL

function sopi_tryToExtract(stru, fields)
   // Attempts to extract some fields from a given structure
   //
   // Calling Sequence
   //    sopi_tryToExtract(stru, fields)
   //
   // Parameters
   //    stru  : the structure where the fields are searched (structure)
   //    fields: the fields that must be extracted (list)
   //
   // Description
   //    This routines tries to extract some fields to a structure. If the field
   //    is found, then a variable with the name of the field and its value is 
   //    returned in the calling workspace.
   //
   if ~isempty(fields) & ~isempty(stru) then
      out = []
      arg = []
      for f = fields
         out = [out;f]
         if isfield(stru, f)
            arg = [arg;'stru.'+f]
         else
            arg = [arg;'[]']
         end
      end
      exStr = '[' + strcat(out,',') + '] = resume(' + strcat(arg,',')+');'
      execstr(exStr)
   end
endfunction
