// Author : Pierre Vuillemin (2017)
// License : GNU GPL

function varList = sopi_varUnion(vl1,vl2)
   // Makes the union between two lists of sopiVar without redundancy
   //
   // Calling Sequence
   //    varList = sopi_varUnion(varList1, varList2)
   //
   // Parameters
   //    varList1 : first list of variables
   //    varList2 : second list of variables
   //    varList  : union of the input list of variables
   //
   // Example
   //    sopi_begin();
   //    x = sopi_var(1,'x');
   //    y = sopi_var(1,'y');
   //    varList = sopi_varUnion(list(x), list(x,y));
   //    disp(varList)
   //
   varList = vl1
   for v = vl2
      if isempty(sopi_findVarPosInList(v,varList))
         varList($+1) = v
      end
   end
endfunction
