// Author : Pierre Vuillemin (2017)
// License : GNU GPL

function P = sopi_vecTranspose(m,n)
   // Computes the matrix P so that vec(M') = P*vec(M)
   //
   // Calling Sequence
   //    P = sopi_vecTranspose(m, n)
   //
   // Parameters
   //    m: number of rows of the matrix
   //    n: number of columns of the matrix
   //    P: transformation matrix
   //
   // Description
   //    This routine is used in sopi_extractLinearForm
   //
   In = eye(n,n)
   P  = [];
   for i = 1:m
      v     = zeros(1,m)
      v(i)  = 1
      P     = [P; In .*. v]
   end
endfunction
