// Author : Pierre Vuillemin (2017)
// License : GNU GPL
// <-- NO CHECK REF -->
mode(-1)
// QP problem in the help page of qld ------------------------------------------
//C1*x = b1 (3 equality constraints i.e me=3)
C1= [1,-1,1,0,3,1;
    -1,0,-3,-4,5,6;
     2,5,3,0,1,0];
b1=[1;2;3];
//C2*x <= b2 (2 inequality constraints i.e md=2)
C2=[0,1,0,1,2,-1;
    -1,0,2,1,1,0];
b2=[-1;2.5];
//with  x between ci and cs:
ci=[-1000;-10000;0;-1000;-1000;-1000];
cs=[10000;100;1.5;100;100;1000];
//and minimize 0.5*x'*Q*x + p'*x with
p=[1;2;3;4;5;6]; Q=eye(6,6);
//No initial point is given;
C=[C1;C2];
b=[b1;b2];
me=3;
[xref,lagr]=qld(Q,p,C,b,ci,cs,me);

// With Sopi -------------------------------------------------------------------
sopi_begin();
x        = sopi_var(6);
bounds   = ci <= x & x <= cs;
eq_cons  = C1*x == b1;
in_cons  = C2*x <= b2;
fun      = x'*(1/2*Q)*x + p'*x;
P        = sopi_min(fun, bounds, eq_cons, in_cons);
// With qld solver
sopi_solve(P,'qld');
assert_checkalmostequal(x.opt, xref)
assert_checkalmostequal(fun.opt, 1/2*xref'*Q*xref + p'*xref)
// with qpsolve
sopi_solve(P,'qpsolve');
assert_checkalmostequal(x.opt, xref)
assert_checkalmostequal(fun.opt, 1/2*xref'*Q*xref + p'*xref)
// with quapro
sopi_solve(P,'quapro');
assert_checkalmostequal(x.opt, xref)
assert_checkalmostequal(fun.opt, 1/2*xref'*Q*xref + p'*xref)
